<template>
  <el-dialog
      :visible.sync="show"
      v-on:update:visible="updateShowDialog"
      width="45%"
      :close-on-press-escape="false"
      :show-close="false"
      custom-class="dialog-orange"
      center>
      <h3 class="text-center">
        <span class="orange-ladrillo-bg text-white" style="padding: 8px 50px; border-radius: 10px"> 
            {{ programSelected.programTitle }} 
        </span>
      </h3>
      <!-- DIAS DE TRANSMISION -->
      <h4 v-if="programSelected.materialHasChapter !== 'No'" style="margin: 2rem 2rem 1.5rem 2rem;"> DÍAS SELECCIONANDOS: </h4>
      <el-row 
        v-if="programSelected.typeOfContent !== 'No'"
        type="flex"
        align="middle"
        style="margin: 1rem 2rem">
        <el-col :span="23">
           <el-checkbox v-model="checkAllDays" style="margin: 1rem 0 1.5rem;" @change="isCheckAllDays"> {{ labelForDaysModal }} </el-checkbox>	
          <el-checkbox-group v-model="saveDays">
            <el-checkbox-button v-for="day in daysShow" :label="day" :key="day">{{day}}</el-checkbox-button>
          </el-checkbox-group>
        </el-col>
      </el-row>
      <div v-show="isShowOptions">
        <h4 style="margin: 1.5rem 2rem"> DATOS ADICIONALES: </h4>
        <el-row :gutter="10" v-if="!isLargometraje(programSelected.typeOfContent)" type="flex" align="middle" style="flex-wrap: wrap; margin: 0rem 2rem">
          <el-col :span="12" v-for="(signal, index) in datosModalCapitulos" :key="index" style="display: flex; align-items: center; margin-bottom: 8px" >
          <el-checkbox v-model="signal.active" style="margin-right: 8px;" class="text-start">{{signal.title}}</el-checkbox>
          <el-color-picker v-model="signal.color" size="mini" show-alpha :predefine="predefineColors" />
          </el-col>
        </el-row>
        <el-row v-else type="flex" align="middle" style="flex-wrap: wrap; margin: 0rem 2rem">
          <el-col :span="12" v-for="(signal, index) in datosModalSinCapitulos" :key="index" style="display: flex; align-items: center; margin-bottom: 8px" >
            <el-checkbox v-model="signal.active" style="margin-right: 8px;" class="text-start">{{signal.title}}</el-checkbox>
            <el-color-picker v-model="signal.color" size="mini" show-alpha :predefine="predefineColors" />
          </el-col>
        </el-row>
      </div>
      <el-row style="margin:0 2rem">
        <NoteWritter v-model="nota" :saveRef="saveRef" ref="noteWritterComponent"/>
        <BackgroundSelector :changeStatusColor="changeStatusColor" ref="backgroundComponent"/>
      </el-row>

      <div class="text-end" style="margin-top:1rem">
        <el-button @click="closeModal"  class="border-orange text-orange" plain>CANCELAR</el-button>
        <el-button type="primary" v-on:click="saveModal()" >ACEPTAR</el-button>              
      </div>
  </el-dialog>
</template>

<script>
import BackgroundSelector from './BackgroundSelector'
import NoteWritter from './NoteWritter'
import {dayNames} from '@/enums.js'
import { daysSpecific } from '@/utils/util.js'

export default {
  name: 'ModalContent',
  props: {
    showDialog: Boolean,
    programSelected: Object,
    closeModal: Function,
    saveInfoModal: Function,
    isShowOptionsModal: Boolean,
    isDayAutoSelect: Array,
    days: Array
  },
  components: {
      BackgroundSelector,
      NoteWritter
  },
  data () {
    return {
      show: this.showDialog,
      checkAllDays: false,
      refTextArea: '',
      saveDays: this.isDayAutoSelect,
      changeStatus: '',
      nota: '',
      predefineColors: [
      '#FF6600',
      '#000099',
      '#FF0000',
      '#993300',
      '#00B0F0',
      'rgba(8, 120, 18, 1)',
      '#FFFFFF',
      'rgba(84, 9, 80, 1)'
      ],
      datosModalCapitulos: [
        {
          title: 'N° del Capítulo',
          active: false,
          color: null   
        },
        {
          title: 'Estado del capítulo',
          active: false,
          color: null   
        },
        {
          title: 'Precio del Capítulo',
          active: false,
          color: null   
        },
        {
          title: 'Precio Por Pasada del Capítulo',
          active: false,
          color: null   
        },
        {
          title: 'N° Temporada',
          active: false,
          color: null   
        },
        {
          title: 'Estado Temporada',
          active: false,
          color: null   
        },
        {
          title: 'Clasificación',
          active: false,
          color: null   
        },
      ],
      datosModalSinCapitulos: [
          {
            title: 'Código de proveedor',
            active: false,
            color: null   
          },
          {
            title: 'Estado',
            active: false,
            color: null   
          },
          {
            title: 'Precio del Material',
            active: false,
            color: null   
          },
          {
            title: 'Precio por pasada',
            active: false,
            color: null   
          },
          {
            title: 'Clasificación',
            active: false,
            color: null   
          },
      ],
      isShowOptions: this.isShowOptionsModal,
      daysShow: this.daysSpecific(this.days)
    }
  },
  methods: {
    isLargometraje(value) {
			if(value == 'Largometrajes' || value == 'LARGOMETRAJES') {
				return true
			} else {
				return false
			}
		},
    updateShowDialog(isVisible) {
      if (isVisible) return false;
      this.$emit('update:showDialog', false )
    },
    saveModal() {
      this.refTextArea = document.body.getElementsByTagName('textarea')[0].className.replace('el-textarea__inner', '')
      // const datosModal= this.programSelected.materialHasChapter !== 'No' ? this.datosModalCapitulos : this.datosModalSinCapitulos
      const datosModal = this.isLargometraje(this.programSelected.typeOfContent) ?  this.datosModalSinCapitulos :this.datosModalCapitulos
      this.closeModal()
      this.saveInfoModal(this.programSelected, this.saveDays, this.changeStatus, this.refTextArea,  this.nota, datosModal)
    },
    isCheckAllDays(data) {
      this.checkAllDays = data
      if(data == true) {
        this.saveDays = this.daysShow
      } else {
        this.saveDays = []
      }
    },
    saveRef(ref) {
      this.refTextArea = ref
    },
    changeStatusColor(color) {
      this.changeStatus = color
    },
    resetModal() {
      this.checkAllDays = false
      this.saveDays = []
      if(this.programSelected.materialHasChapter !== 'No') {
        this.datosModalCapitulos = this.resetDate(this.datosModalCapitulos)
      } else {
        this.datosModalSinCapitulos = this.resetDate(this.datosModalSinCapitulos)
      }
      this.nota = ''
      this.$refs.backgroundComponent.resetBgColors()
      this.$refs.noteWritterComponent.resetNote()
      this.changeStatusColor('')
    },
    resetDate(value) {
      const data = value.map((e) => ({
        title: e.title,
        active:  false,
        color:  null
      }))
      return data
    },
    restoreClassInNote() {
      this.$refs.noteWritterComponent.addClassTextArea()
    },
    daysSpecific(data) {
      let days = data.map((e) => {
        let response = e.completeDate.split(' ')
        return response[0]
      })
      return days
    }
  },
  computed: {
    labelForDaysModal() {
      let couterDays = daysSpecific(this.days)
      if(couterDays.length >= 2) {
        let conditional = couterDays.length == 2 ? `${couterDays[0]} y ${couterDays[1]}` : `${couterDays[0]} a ${couterDays[couterDays.length -1]}`
        return conditional
      } else {
        return couterDays[0]
      }
    }
	},
  watch: {
    saveDays (val) {
      if(val.length == this.daysShow.length){
				this.checkAllDays = true
			} else {
				this.checkAllDays = false
			}
    },
    checkAllDays(val) {
      if(val) {
        this.saveDays = this.daysShow
      }else {
        this.saveDays = []
      }
    },
    daysShow(val) {
      console.log(val, 'daysShow')
    }
  },
  created() {
    this.checkAllDays = this.isDayAutoSelect.length > 0 ? true : false
  }
}
</script>

<style>
  .el-button--text {
    display: none !important;
  }
</style>
